#include <bits/stdc++.h>
using namespace std;

using ll = long long;
using LL = long long;
using i64 = long long;
using f80 = long double;

void solve() {
    int n; cin >> n;
    vector<vector<i64>> grid(n, vector<i64>(n));
    for (auto &row: grid)
        for (auto &el: row)
            cin >> el;

    f80 d1 = 0, d2 = 0;

    for (i64 sx = 0; sx < n; sx++) {
        for (i64 sy = 0; sy < n; sy++) {
            vector<vector<bool>> vis(n * n * n + n, vector<bool>(n));
            vector<vector<i64>> dst(n * n * n + n, vector<i64>(n, 1e18));
            priority_queue<
                tuple<i64, i64, i64>,
                vector<tuple<i64, i64, i64>>,
                greater<>
            > q;

            q.emplace(0, sx, sy);
            while (!q.empty()) {
                auto [d, x, y] = q.top(); q.pop();
                if (vis[x][y]) continue;
                vis[x][y] = true;
                dst[x][y] = d;

                if (x > 0) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[(x - 1) % n][y % n]), x - 1, y);
                }
                if (y > 0) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[x % n][(y - 1) % n]), x, y - 1);
                }
                if (x < n * n * n + n - 1) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[(x + 1) % n][y % n]), x + 1, y);
                }
                if (y < n - 1) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[x % n][(y + 1) % n]), x, y + 1);
                }
            }

            for (int i = 1; i <= n * n; i++) {
                d1 = max(d1, (f80)2e20 / dst[sx + i * n][sy] * i);
            }
        }
    }

    vector<vector<i64>> trasp(n, vector<i64>(n));
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            trasp[i][j] = grid[j][i];
        }
    }
    grid = trasp;

    for (i64 sx = 0; sx < n; sx++) {
        for (i64 sy = 0; sy < n; sy++) {
            vector<vector<bool>> vis(n * n * n + n, vector<bool>(n));
            vector<vector<i64>> dst(n * n * n + n, vector<i64>(n, 1e18));
            priority_queue<
                tuple<i64, i64, i64>,
                vector<tuple<i64, i64, i64>>,
                greater<>
            > q;

            q.emplace(0, sx, sy);
            while (!q.empty()) {
                auto [d, x, y] = q.top(); q.pop();
                if (vis[x][y]) continue;
                vis[x][y] = true;
                dst[x][y] = d;

                if (x > 0) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[(x - 1) % n][y % n]), x - 1, y);
                }
                if (y > 0) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[x % n][(y - 1) % n]), x, y - 1);
                }
                if (x < n * n * n + n - 1) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[(x + 1) % n][y % n]), x + 1, y);
                }
                if (y < n - 1) {
                    q.emplace(d + 1 + abs(grid[x % n][y % n] - grid[x % n][(y + 1) % n]), x, y + 1);
                }
            }

            for (int i = 1; i <= n * n; i++) {
                d2 = max(d2, (f80)2e20 / dst[sx + i * n][sy] * i);
            }
        }
    }

    cerr << d1 << endl;
    cout << setprecision(10) << d1 * d2 / 2 * n * n << '\n';
}

int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    solve();
}