#include <bits/stdc++.h>
using namespace std;

#define int LL

using ll = long long;
using LL = long long;
using i64 = long long;
#define all(x) begin(x), end(x)

LL sgn(LL x) { // circa
	return x > 0 ? 1 : -1; 
}

void solve() {
	int n; cin >> n;
	LL a; cin >> a;
	LL b; cin >> b;	
	vector<LL> d(n-1);
	for (int i = 0; i < n-1; ++i)
		cin >> d[i];
	vector<int> id(n-1);
	iota(all(id), 0);
	sort(all(id), [&](LL i, LL j){
		return d[i] < d[j];
	});
	LL s = 0;
	for (int i = 0; i < n-1; ++i) {
		s += d[i];
	}
	if ((s + a + b) % 2 != 0 || s < a + b) {
		cout << "NO\n";
		return;
	}
	if (2 * d[id[n-2]] > a + b + s) {
		cout << "NO\n";
		return;
	}

	LL C = (s - a - b) / 2;
	vector<array<LL, 2>> pts(n);
	for (int i = n-2; i >= 0; --i) {
		int j = id[i];
		assert(2 * d[j] <= abs(a) + abs(b) + s);
		assert(s >= a + b);
		/*
		if (2 * d[j] > abs(a) + abs(b) + s) {
			cout << "NO\n";
			return;
		}
		*/
		if (d[j] <= C) {
			pts[j+1][0] = d[j] * (-sgn(a));
			C -= d[j];
		} else if (d[j] - C <= abs(a)) {
			pts[j+1][0] = sgn(a) * (d[j] - C);
			pts[j+1][1] = C * (-sgn(b));
			C = 0;
		} else if (d[j] - C <= abs(b)) {
			pts[j+1][0] = C * (-sgn(a));
			pts[j+1][1] = sgn(b) * (d[j] - C);
			C = 0;
		} else {
			// faccio solo mosse buone
			pts[j+1][0] = sgn(a) * min(d[j], abs(a));
			pts[j+1][1] = sgn(b) * (d[j] - abs(pts[j+1][0]));
		}
		a -= pts[j+1][0];
		b -= pts[j+1][1];
		s -= d[j];
	}
	if (a != 0 || b != 0) {
		cout << "NO\n";
		return;
	}
	
	for (int i = 1; i < n; ++i) {
		pts[i][0] += pts[i - 1][0];
		pts[i][1] += pts[i - 1][1];
	}
	cout << "YES\n"; // !
	for (int i = 0; i < n; ++i)
		cout << pts[i][0] << " " << pts[i][1] << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    int t = 1;
    while (t--) solve();
}
